# noname: analysis of privacy in security protocols

## Installation

### Building from source

noname is written in Haskell. One should have already installed GHC 9.2.7 (base
4.16) or above and cabal-install 3 or above. If that is not the case,
installation via [GHCup](https://www.haskell.org/ghcup/) is recommended.

noname relies on the external [SMT solver
cvc5](https://cvc5.github.io/downloads.html). Please make sure that the `cvc5`
executable is in your path.

The recommended way to build the noname tool is to simply run `make`. By
default, the executable `noname` will be copied into the current folder. It is
also possible to install it to another location with `make install DIR=<PATH>`,
where the default is `DIR=$HOME/.local/bin`.

### Prebuilt executable

An executable is available as an [ELF
file](https://people.compute.dtu.dk/lpkf/sources/noname). It requires glibc 2.34
or above. Tested on:
- Arch Linux
- Ubuntu 22.04.3 LTS (Jammy Jellyfish)

## Usage

To run the tool, call `noname` on a file containing a protocol specification. By
default the verification will work up to the bound specified in the input file
and will be fully automatic. You can override the defaults to specify a bound or
start interactive mode. In the interactive mode, the tool displays the current
state of the symbolic execution of the protocol and requires user input to
explore the reachable states.

```
noname - formal verification of privacy in security protocols

Usage: noname (INPUT | --stdin) [-o|--output OUTPUT] [-n|--bound INT] 
              [-i|--interactive] [-q|--quiet]

  Verify an (alpha, beta)-privacy specification

Available options:
  INPUT                    Read from INPUT file
  --stdin                  Read from stdin
  -o,--output OUTPUT       Write to OUTPUT file
  -n,--bound INT           Set bound to INT (overrides bound specified in the
                           input)
  -i,--interactive         Use interactive mode
  -q,--quiet               Whether to be quiet
  -h,--help                Show this help text
  -v,--version             Show version information
```

Note that noname is able to use multiple cores. By default, only 1 core is used
but one can set at run time the number of cores used with `noname <ARGUMENTS>
+RTS -N<x>`, where `x` is the number (if `x` is omitted, this uses all available
cores).

noname uses UTF-8 encoding for both input and output.
